%{?!with_cache: %global with_cache 0}

Name: jwhois
Version: 4.0
Release: 2%{?dist}
URL: http://www.gnu.org/software/jwhois/
Source0: ftp://ftp.gnu.org/gnu/jwhois/jwhois-%{version}.tar.gz
Source1: https://raw.githubusercontent.com/robert-scheck/jwhois/2bd561e06ca37cf6c2ef9f0a2e957e09f58e6972/example/jwhois.conf
Patch0: jwhois-4.0-connect.patch
Patch1: jwhois-4.0-ipv6match.patch
Patch2: jwhois-4.0-fclose.patch
Patch3: jwhois-4.0-select.patch
Patch5: jwhois-4.0-multi-homed.patch
Patch6: jwhois-4.0-libidn2.patch
Patch7: jwhois-4.0-idna.patch
Patch8: jwhois-4.0-idnfail.patch
Patch9: jwhois-4.0-ipv4_ipv6.patch
Patch10: jwhois-configure-c99.patch
Patch11: jwhois-c99.patch
License: GPL-3.0-only
Summary: Internet whois/nicname client
BuildRequires: gcc, libidn2-devel, autoconf, automake
%if %{with_cache}
BuildRequires: gdbm-devel
%endif
BuildRequires: make
Requires(post): %{_sbindir}/update-alternatives
Requires(preun): %{_sbindir}/update-alternatives

%global genname whois
%global alternative jwhois

%description
A whois client that accepts both traditional and finger-style queries.

%prep
%setup -q
%autopatch -p1

iconv -f iso-8859-1 -t utf-8 < doc/sv/jwhois.1 > doc/sv/jwhois.1_
mv doc/sv/jwhois.1_ doc/sv/jwhois.1

cp -pf %{SOURCE1} example/jwhois.conf

autoreconf

%build
%if %{with_cache}
%configure --enable-sgid --localstatedir=%{_localstatedir}/cache/jwhois
%else
%configure
%endif
make %{?_smp_mflags}

%install
rm -fr %{buildroot}
make install DESTDIR="%{buildroot}"

%if %{with_cache}
echo 'cachefile = "/var/cache/jwhois/jwhois.db";' >> %{buildroot}/etc/jwhois.conf
install -m0775 -d %{buildroot}/%{_localstatedir}/cache/jwhois
touch %{buildroot}/%{_localstatedir}/cache/jwhois/jwhois.db
%endif

rm -f "%{buildroot}"%{_infodir}/dir
%find_lang jwhois

echo .so man1/jwhois.1 > %{buildroot}/%{_mandir}/man1/whois.%{alternative}.1

touch %{buildroot}%{_bindir}/whois
chmod 755 %{buildroot}%{_bindir}/whois
touch %{buildroot}%{_mandir}/man1/whois.1

%files -f %{name}.lang
%doc AUTHORS COPYING ChangeLog NEWS README TODO
%if %{with_cache}
%attr(2755,root,jwhois) %{_bindir}/jwhois
%attr(2775,root,jwhois) %{_localstatedir}/cache/jwhois/jwhois.db
%else
%attr(0755,root,root) %{_bindir}/jwhois
%endif
%ghost %verify(not md5 size mtime) %{_bindir}/whois
%{_mandir}/man1/jwhois.1*
%lang(sv) %{_mandir}/sv/man1/jwhois.1*
%{_mandir}/man1/whois.%{alternative}.*
%ghost %verify(not md5 size mtime) %{_mandir}/man1/whois.1.gz
%{_infodir}/jwhois.info.*
%config(noreplace) %{_sysconfdir}/jwhois.conf

%if %{with_cache}
%pre
getent group jwhois >/dev/null || groupadd -r jwhois || :
%endif

%post
rm -f /usr/share/man/man1/whois.1.gz
%{_sbindir}/update-alternatives \
    --install %{_bindir}/whois \
        %{genname} %{_bindir}/jwhois 60 \
    --slave %{_mandir}/man1/whois.1.gz \
        %{genname}-man %{_mandir}/man1/whois.%{alternative}.1.gz

%preun
if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives --remove \
            %{genname} %{_bindir}/jwhois
fi

%changelog
* Fri May 10 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0-2
- debrand macros

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0-1
- initial build
